// Pogon.java - Primer program za obradu predmeta u skladistu.

class MojRadnik extends Radnik {
  private String ime;
  public MojRadnik (Red skladiste, Obrada obrada, String ime)
    { super (skladiste, obrada); this.ime = ime; }
  public String toString () { return ime; }
}

class MojaObrada extends Obrada {
  static public int maxPredmet=3;
  private Red skladiste;
  MojaObrada (Red ss) { skladiste = ss; }
  public void radi (Radnik rr, Object pp) {
    String predmet = (String) pp;
    String ime = rr.toString ();
    System.out.println (ime + " < " + predmet);
    for (int i=0; i<(int)(Math.random()*maxPredmet); i++) {
      predmet = ime + " > " + Math.random ();
      skladiste.stavi (predmet);
      System.out.println (predmet);
    }
  }
}

class Pogon {
  static public void main (String[] argi) {
    String[] imena = {"Marko", "Zoran", "Petar", "Jovan"};
    Radnik[] radnici = new Radnik [imena.length];
    Red skladiste = new Red ();
    Obrada obrada = new MojaObrada (skladiste);
    for (int i=0; i<radnici.length; i++) {
      (radnici[i] = new MojRadnik (skladiste, obrada, imena[i])).start ();
    }
    skladiste.stavi ("Pocetni predmet");
    for (boolean dalje=true; dalje; dalje = ! dalje) {
      try { Thread.sleep (100); } catch (InterruptedException g) {}
      for (int i=0; i<radnici.length; i++) {
        dalje = dalje && radnici[i].slobodan ();
      }
    }
    for (int i=0; i<radnici.length; radnici[i++].stop ());
  }
}
