// Radnik.java - Klasa radnika za obradu predmeta u skladistu.
class Radnik extends Thread {
  private Red skladiste;
  private Obrada obrada;
  private boolean zauzet = false;
  public Radnik (Red ss, Obrada oo) { skladiste = ss; obrada = oo; }
  public boolean slobodan () { return ! zauzet; }
  public void run () {
    while (true) {
      Object predmet = skladiste.uzmi ();
      zauzet = true;
      obrada.radi (this, predmet);
      zauzet = false;
    }
  }
}
