// Usluge.java - Razne elementarne usluge opste namene.

class Usluge {

  public static char citajChar () {  // Citanje jednog znaka.
    try { return (char)System.in.read(); }
      catch (Exception e) { return ' '; }
  }

  public static String citajString () {  // Citanje jedne reci.
    try { char c; String s="";
      while ( Character.isSpace(c=(char)System.in.read())); s += c;
      while (!Character.isSpace(c=(char)System.in.read()))  s += c;
      return s;
    } catch (Exception e) { return "";  }
  }

  public static String citajLiniju () {  // Citanje jedne linije teksta.
    try {
      char c; String s="";
      while ((c=(char)System.in.read()) != '\n') s += c;
      return s;
    } catch (Exception e) { return "";  }
  }

  //public static byte   citajByte   () // Citanje jednog podatka tipa byte
  //  { return Byte.valueOf   (citajString ()).byteValue   (); }

  //public static short  citajShort  () // Citanje jednog podatka tipa short
  //  { return Short.valueOf  (citajString ()).shortValue  (); }

  public static int    citajInt    () // Citanje jednog podatka tipa int
    { return Integer.valueOf (citajString ()).intValue   (); }

  public static long   citajLong   () // Citanje jednog podatka tipa long
    { return Long.valueOf   (citajString ()).longValue   (); }

  public static float  citajFloat  () // Citanje jednog podatka tipa float
    { return Float.valueOf  (citajString ()).floatValue  (); }

  public static double citajDouble () // Citanje jednog podatka tipa double
    { return Double.valueOf (citajString ()).doubleValue (); }
}
